/*
 * @author Juan J. Durillo
 * @version 1.0
 * 
 * JMetalDialog.java
 * 
 * This class implements a JMetalDialog for printing out all the informatin
 * generated by jMetal.
 */

package jmetal.gui.components;

import java.awt.Dimension;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Toolkit;
import java.io.OutputStream;
import javax.swing.JDialog;
import javax.swing.JScrollPane;


public class JMetalDialog extends OutputStream {

  private JDialog jDialog_;
  private TextComponent content_  = new TextArea("",1,1,TextArea.SCROLLBARS_VERTICAL_ONLY);

  public JMetalDialog(String title) {
    super();

    jDialog_ = new JDialog();
    jDialog_.setTitle(title);
    jDialog_.setSize(800, 600);
    jDialog_.setMaximumSize(new Dimension(800,600));
    jDialog_.setMinimumSize(new Dimension(800,600));
    jDialog_.setResizable(false);
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    Dimension screenSize = toolkit.getScreenSize();
    jDialog_.setLocation(screenSize.width / 2 - 800 / 2,
                  screenSize.height / 2 - 600 / 2);
    jDialog_.add((new JScrollPane()).add(content_));

  }

  @Override
  public void write(byte[] b){
    content_.setText(new String(b) + content_.getText());
    //((TextArea)content_).append(new String(b));
  }

  @Override
  public void write(byte[] b, int off, int len){
    content_.setText(new String(b,off,len) + content_.getText());
    //((TextArea)content_).append(new String(b,off,len));
  }

  @Override
  public void write(int b){
    byte[] b1 = {(new Integer(b)).byteValue()};
    this.write(b1);
  }

  public void setVisible() {
    jDialog_.setVisible(true);
  }

  public void setInvisible() {
    jDialog_.setVisible(false);
  }

}

